package interestRate;

/**
   Implements a doubly linked list.
   @author Somesh Jha
   */
public class LinkList {

  //Head of the list
  Node head;

  static final boolean DEBUG=false;

  //constructor
  public LinkList() {
    head = null;
  }//end of LinkList

  /**
     Insert a new node if doesn't
     exist with key k
     */
  public Node Insert(KeyInterface k) {
    if (DEBUG) {
      System.out.print("Inserting node with key: ");
      k.print();
    }
    Node x;
    if (head == null) {
      x = new Node(k);
      head=x;
    }
    else {
      x = head.InsertElement(k);
    }
    return(x);
  }//end of Insert

  /** 
      Delete a node with a certain key if it exist.
      @exception LinkListException Thrown when the linked-list is empty.
      */
  public void Delete(KeyInterface k) throws LinkListException {
    if (DEBUG) {
      System.out.print("Deleting node with key: ");
      k.print();
    }

    if (head == null) {
      throw new LinkListException("Deleting from an empty list");
    }
    else {
      //Find the element
      Node x = head.Search(k);
      if (x != null) {
	x.print();
	
	if (head == x) {
	  head = head.next;
	}
	x.Delete();
      }
    }//end of else
  }//end of Delete

  /**
     print the LinkList
     @exception LinkListException Thrown when the linked-list is empty.
     */
  public void print() throws LinkListException {
    if (head == null) 
      throw new LinkListException("Printing an empty list");
    else {
      System.out.println("-----------------BEGIN-----------------------");
      head.print();
      System.out.println("-----------------END-----------------------");
    }
  }


}//end of LinkList
  
  
