/**
 * The <code>BSTList</code> class is a hybrid linked list
 * and binary search tree class.  The majority of functionality
 * is found in the BSTNode class.  See the assignment document
 * for details.
 * <p>
 *
 * You must fill in the methods in the BSTNode class.
 *
 * @author  Jeff Stephenson
 */

package optionCalc;

public class BSTList
{
    
    /**
     * The head of the list, and root of the binary search tree
     */
    BSTNode head;

    /**
     * A (boolean) flag value used for debugging
     */
    static final boolean DEBUG=false;

    /**
     * Do your initialization here.
     */
    public BSTList() 
    {
        head = null;
    }

    /**
     * Searches the binary search tree for a node with
     * an equal key.  If one is not found, a new node 
     * with key data k is inserted.
     *
     * @param   k			the (KeyInterface) data to insert
     */

    public Node Insert(KeyInterface k) 
    {
        if (DEBUG) 
        {
            System.out.print("Inserting node with key: ");
            k.printKey();
        }
        
        BSTNode x;
        if (head == null) 
        {
            x = new BSTNode(k);
            head=x;
        }
        else 
        {
            x = (BSTNode) head.InsertElement(k);
        }
  
        return((Node) x);
    }


    /**
     * Prints the BSTList Object
     *
     * @exception LinkListException Thrown when the linked-list is empty.
     */
    public void printList() throws LinkListException 
    {
        if (head == null) 
        {
            throw new LinkListException("Printing an empty list");
        }
        else 
        {
            System.out.println("-----------------BEGIN-----------------------");
            head.printNode();
            System.out.println("-----------------END-----------------------");
        }
    }

}

