/**
 * The <code>BSTNode</code> class is an extension of the Node class
 * that provides support for a binary search tree on top of the 
 * linked list representation.  
 *
 * <p>
 * For part 3 of the homework, you must fill in the methods below, 
 * as well as those in the BSTList class.  
 *
 * Put your name in the author field below!
 *
 * @author  
 */

package optionCalc;

public class BSTNode extends Node
{
    /**
     * A reference to the left subtree
     */
    public BSTNode left;

    /**
     * A reference to the right subtree
     */
    public BSTNode right;


    /**
     * Do your initialization here.
     */
    public BSTNode(KeyInterface k) 
    {
        super(k);
        left = null;
        right = null;
    }

    /**
     * Inserts the given key in the binary search
     * tree and adds it to the linked list (if it has
     * not already been inserted).  Returns a reference
     * to the inserted/found node.
     *
     * @param   k			the (KeyInterface) data to insert
     */
    public Node InsertElement(KeyInterface k) 
    {
        BSTNode x = this;
        BSTNode prev = null;
        boolean lessThan = false;

        while (x != null) 
        {
            if (x.key.isEqual(k))  
            {
                return(x);
            }
            else 
            {
                prev = x;
                lessThan = x.key.isLessThan(k);
                if (lessThan)
                {
                    x = x.right;
                }
                else
                {
                    x = x.left;
                }
            }
        }
        //didn't find the key

        x = new BSTNode(k);
        if (lessThan)
        {
            prev.right = x;
        }
        else
        {
            prev.left = x;
        }

        InsertAfter(x);
        return (Node) x;
    
    }

}

